//+------------------------------------------------------------------+
//|                                                rsx on oma smooth |
//|                                                           mladen |
//|           trendstrength mod by mrtools so any bugs theit mrtools | 
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers   3
#property indicator_color1    Yellow
#property indicator_style1    STYLE_DASH
#property indicator_color2    LimeGreen
#property indicator_width2    2 
#property indicator_color3    Red
#property indicator_width3    2 

//
//
//
//
//
extern int    RsxLength         = 14;
extern int    Price             = 0;
extern int    OmaLength         = 5;
extern double OmaSpeed          = 8.0;
extern bool   OmaAdaptive       = true;
extern int    deltaPrice        = 0;
extern int    deltaOmaLength    = 5;
extern double deltaOmaSpeed     = 8.0;
extern bool   deltaOmaAdaptive  = true;
extern double K                 = 4.236; // Multiplier  
extern bool   Hideindicatorname = true;


//
//
//
//
//

double rsx[];
double UpTrend[];
double DnTrend[];
double smin[];
double smax[];
double atrrsx[];
double Delta[];
double trend[];
double wrkBuffer[][13];
double stored[][14];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,rsx);     SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,UpTrend); SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,DnTrend); SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,smin);
   SetIndexBuffer(4,smax);
   SetIndexBuffer(5,atrrsx);
   SetIndexBuffer(6,Delta);
   SetIndexBuffer(7,trend);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   
   OmaLength = MathMax(OmaLength,   1);
   OmaSpeed  = MathMax(OmaSpeed ,-1.5);
   
   if (Hideindicatorname)
   {
   IndicatorShortName(""); 
   }
   else
   IndicatorShortName("oma trend strength ("+RsxLength+","+OmaLength+","+DoubleToStr(OmaSpeed,2)+")");
   
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   K=K/100;
   }
   
   return(0);
}
int deinit() { return(0); }




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(wrkBuffer,0) != Bars) { ArrayResize(wrkBuffer,Bars); ArrayResize(stored,Bars); }

   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+RsxLength);
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][12] = iAverage(iMA(NULL,0,1,0,MODE_SMA,Price,i),OmaLength,OmaSpeed,OmaAdaptive,r,0);

         if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double roc = wrkBuffer[r][12]-wrkBuffer[r-1][12];
      double roa = MathAbs(roc);
      for (int k=0; k<3; k++)
      {
         int kk = k*2;
            wrkBuffer[r][kk+0] = Kg*roc                + Hg*wrkBuffer[r-1][kk+0];
            wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; roc = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
            wrkBuffer[r][kk+6] = Kg*roa                + Hg*wrkBuffer[r-1][kk+6];
            wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; roa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
      }
      if (roa != 0)
           rsx[i] = MathMax(MathMin((roc/roa+1.0)*50.0,100.00),0.00); 
      else rsx[i] = 50.0;
   
      if(rsx[i] > rsx[i+1]) {double hrsx = rsx[i]; double lrsx = rsx[i+1];}
      else 
      if(rsx[i] < rsx[i+1]) {hrsx = rsx[i+1]; lrsx = rsx[i];}
      else
      {hrsx = rsx[i]; lrsx = rsx[i];}
   
      atrrsx[i] = hrsx - lrsx;
      Delta[i] = iAverage(iMA(atrrsx[i],0,2*RsxLength-1,0,MODE_SMA,deltaPrice,i),deltaOmaLength,deltaOmaSpeed,deltaOmaAdaptive,r,7); 
   
      smin[i] = rsx[i] - K*Delta[i]; 
      smax[i] = rsx[i] + K*Delta[i];
      
      trend[i] = trend[i+1];
   
      if (rsx[i]>smax[i+1])  trend[i]= 1; 
	   if (rsx[i]<smin[i+1])  trend[i]=-1;

      if(trend[i]>0)
	   {
	   if (smin[i]<smin[i+1]) smin[i]=smin[i+1];
	   UpTrend[i]=smin[i];
	   DnTrend[i]=EMPTY_VALUE;
	   }
	   else
	   if(trend[i]<0)
	   {
	   if(smax[i]>smax[i+1]) smax[i]=smax[i+1];
	   DnTrend[i]=smax[i];
	   UpTrend[i]=EMPTY_VALUE;
	   }
	   }

   return(0);
  }

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

#define E1  0
#define E2  1
#define E3  2
#define E4  3
#define E5  4
#define E6  5
#define res 6

//
//
//
//
//

double iAverage(double price, double averagePeriod, double const, bool adaptive, int r, int ashift=0)
{
   double e1=stored[r-1][E1+ashift];  double e2=stored[r-1][E2+ashift];
   double e3=stored[r-1][E3+ashift];  double e4=stored[r-1][E4+ashift];
   double e5=stored[r-1][E5+ashift];  double e6=stored[r-1][E6+ashift];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = averagePeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         int    endPeriod = MathCeil(maxPeriod);
         double signal    = MathAbs((price-stored[r-endPeriod][res]));
         double noise     = 0.00000000001;

            for(int k=1; k<endPeriod; k++) noise=noise+MathAbs(price-stored[r-k][res]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double alpha = (2.0+const)/(1.0+const+averagePeriod);

      e1 = e1 + alpha*(price-e1); e2 = e2 + alpha*(e1-e2); double v1 = 1.5 * e1 - 0.5 * e2;
      e3 = e3 + alpha*(v1   -e3); e4 = e4 + alpha*(e3-e4); double v2 = 1.5 * e3 - 0.5 * e4;
      e5 = e5 + alpha*(v2   -e5); e6 = e6 + alpha*(e5-e6); double v3 = 1.5 * e5 - 0.5 * e6;

   //
   //
   //
   //
   //

   stored[r][E1+ashift]  = e1;  stored[r][E2+ashift] = e2;
   stored[r][E3+ashift]  = e3;  stored[r][E4+ashift] = e4;
   stored[r][E5+ashift]  = e5;  stored[r][E6+ashift] = e6;
   stored[r][res+ashift] = price;
   return(v3);
}